package test;

public class TestCesarCodeImpl2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestCesarCodeImpl2();
    }

    protected void runTests() {
        this.testExpected = 13;
        try {
            testSuperTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetName();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetShiftLevel();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testEncode();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testDecode();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testSuperTypes() {
        crypto.CesarCodeImpl p = new crypto.CesarCodeImpl(2);
        assertInstanceOf(p, crypto.Code.class);
    }

    public void testGetName() {
        crypto.CesarCodeImpl p = new crypto.CesarCodeImpl(2);

        String expected = "Cesar Algorithm";
        String value = p.getName();
        assertEquals(expected, value);
    }

    public void testGetShiftLevel() {
        crypto.CesarCodeImpl p = new crypto.CesarCodeImpl(2);

        int expectedS = 2;
        int valueS = p.getShiftLevel();
        assertEquals(expectedS, valueS);

        p = new crypto.CesarCodeImpl(8);

        expectedS = 8;
        valueS = p.getShiftLevel();
        assertEquals(expectedS, valueS);

        p = new crypto.CesarCodeImpl(0);

        expectedS = 0;
        valueS = p.getShiftLevel();
        assertEquals(expectedS, valueS);
    }

    public void testEncode() {
        crypto.CesarCodeImpl p = new crypto.CesarCodeImpl(1);

        String expected = "FTJBM";
        String value = p.encode("ESIAL");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(2);
        expected = "GUKCN";
        value = p.encode("ESIAL");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(13);
        expected = "REVNY";
        value = p.encode("ESIAL");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(0);
        expected = "ESIAL";
        value = p.encode("ESIAL");
        assertEquals(expected, value);
    }

    public void testDecode() {
        crypto.CesarCodeImpl p = new crypto.CesarCodeImpl(1);

        String expected = "ESIAL";
        String value = p.decode("FTJBM");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(2);

        expected = "ESIAL";
        value = p.decode("GUKCN");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(13);
        expected = "ESIAL";
        value = p.decode("REVNY");
        assertEquals(expected, value);

        p = new crypto.CesarCodeImpl(0);
        expected = "ESIAL";
        value = p.decode("ESIAL");
        assertEquals(expected, value);
    }
}
