package test;

public class TestRandomKeyCodeImpl2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestRandomKeyCodeImpl2();
    }

    protected void runTests() {
        this.testExpected = 18;
        try {
            testSuperTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGenerateKey();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetName();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetSecretKey();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetKeyLength();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testEncodeDecode();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testSuperTypes() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(2);
        assertInstanceOf(p, crypto.KeyBased.class);
        assertInstanceOf(p, crypto.Code.class);
        assertInstanceOf(p, crypto.SecretKeyCodeImpl.class);
    }

    public void testGetName() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(2);

        String expected = "Algorithm using Random Key";
        String value = p.getName();
        assertEquals(expected, value);
    }

    public void testGetSecretKey() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(2);

        int expected = 2;
        int value = p.getSecretKey().length();
        assertEquals(expected, value);

        p = new crypto.RandomKeyCodeImpl(5);

        expected = 5;
        value = p.getSecretKey().length();
        assertEquals(expected, value);

        p = new crypto.RandomKeyCodeImpl(0);

        expected = 0;
        value = p.getSecretKey().length();
        assertEquals(expected, value);
    }

    public void testGetKeyLength() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(2);

        int expected = 2;
        int value = p.getKeyLength();
        assertEquals(expected, value);

        p = new crypto.RandomKeyCodeImpl(5);

        expected = 5;
        value = p.getKeyLength();
        assertEquals(expected, value);

        p = new crypto.RandomKeyCodeImpl(0);

        expected = 0;
        value = p.getKeyLength();
        assertEquals(expected, value);
    }

    public void testEncodeDecode() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(2);

        String expected = "TROP DE SECRET";
        String value = p.encode("TROP DE SECRET");
        assertNotEquals(expected, value);

        p = new crypto.RandomKeyCodeImpl(2);
        expected = "TROP DE SECRET";
        value = p.decode(p.encode("TROP DE SECRET"));
        assertEquals(expected, value);

        /*
        p = new crypto.RandomKeyCodeImpl(0);
        expected = "TROP DE SECRET";
        value = p.encode("TROP DE SECRET");
        assertEquals(expected, value);
         */

        p = new crypto.RandomKeyCodeImpl(2);
        value = p.encode("ABAB");
        assertEquals(value.charAt(0), value.charAt(2));
        assertEquals(value.charAt(1), value.charAt(3));
    }

    public void testGenerateKey() {
        crypto.RandomKeyCodeImpl p = new crypto.RandomKeyCodeImpl(0);

        String expected = p.generateKey(1);
        String value = p.generateKey(1);
        assertNotEquals(expected, value);

        value = p.generateKey(1);
        assertTrue(value.length() == 1, "generateKey(1) should return a key of size 1");

        value = p.generateKey(5);
        assertTrue(value.length() == 5, "generateKey(5) should return a key of size 5");

        value = p.generateKey(0);
        assertTrue(value.length() == 0, "generateKey(0) should return a key of size 0");

    }
}
