package test;

public class TestSecretKeyCodeImpl2 extends AbstractTest {

    public static void main(String[] args) throws InstantiationException, IllegalAccessException {
        new TestSecretKeyCodeImpl2();
    }

    protected void runTests() {
        this.testExpected = 14;
        try {
            testSuperTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetName();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetSecretKey();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testGetKeyLength();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testEncode();
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            testDecode();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void testSuperTypes() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("R2D2");
        assertInstanceOf(p, crypto.KeyBased.class);
        assertInstanceOf(p, crypto.Code.class);
    }

    public void testGetName() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("Algorithm using Secret Key");

        String expected = "Algorithm using Secret Key";
        String value = p.getName();
        assertEquals(expected, value);
    }

    public void testGetSecretKey() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("R2D2");

        String expected = "R2D2";
        String value = p.getSecretKey();
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl("C3PO");

        expected = "C3PO";
        value = p.getSecretKey();
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl(null);

        expected = null;
        value = p.getSecretKey();
        assertTrue(expected == value, "Secret key should be null if it was set to be null");
    }

    public void testGetKeyLength() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("R2D2");

        int expectedS = 4;
        int valueS = p.getKeyLength();
        assertEquals(expectedS, valueS);

        p = new crypto.SecretKeyCodeImpl("CODE2509");

        expectedS = 8;
        valueS = p.getKeyLength();
        assertEquals(expectedS, valueS);
    }

    public void testEncode() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("ESIAL");

        String expected = "XIWPKHWHSPGIMT";
        String value = p.encode("TROP DE SECRET");
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl("ESIAL");
        expected = "IJQAW";
        value = p.encode("ESIAL");
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl("ESIAL");
        expected = "";
        value = p.encode("");
        assertEquals(expected, value);

        /*
        p = new crypto.SecretKeyCodeImpl("");
        expected = "ESIAL";
        value = p.encode("ESIAL");
        assertEquals(expected, value);
         */
    }

    public void testDecode() {
        crypto.SecretKeyCodeImpl p = new crypto.SecretKeyCodeImpl("ESIAL");

        String expected = "TROP DE SECRET";
        String value = p.decode("XIWPKHWHSPGIMT");
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl("ESIAL");

        expected = "ESIAL";
        value = p.decode("IJQAW");
        assertEquals(expected, value);

        p = new crypto.SecretKeyCodeImpl("ESIAL");
        expected = "";
        value = p.decode("");
        assertEquals(expected, value);

        /*
        p = new crypto.SecretKeyCodeImpl("");
        expected = "ESIAL";
        value = p.decode("ESIAL");
        assertEquals(expected, value);
         */
    }
}
